#region Namespace References

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Web;

#endregion

namespace BarcodeSample_Assembly_
{
    public partial class AboutBox : Form
    {
        public AboutBox()
        {
            InitializeComponent();
            // Use reflection to pull name and version info from the assembly for display in the about box.
            System.Reflection.Assembly info = System.Reflection.Assembly.GetExecutingAssembly();
            VersionInfo.Text = "Version: " + info.GetName().Version.ToString();
            // We pull the copyright, description and product attributes.
            object[] objs = info.GetCustomAttributes(false);
            for (int n = 0; n < objs.Length; n++)
            {
                if( objs[n] is System.Reflection.AssemblyCopyrightAttribute )
                {
                    System.Reflection.AssemblyCopyrightAttribute copyright = objs[n] as System.Reflection.AssemblyCopyrightAttribute;
                    CopyrightStatement.Text = copyright.Copyright;
                }
                else if (objs[n] is System.Reflection.AssemblyDescriptionAttribute)
                {
                    System.Reflection.AssemblyDescriptionAttribute description = objs[n] as System.Reflection.AssemblyDescriptionAttribute;
                    AppDescription.Text = description.Description;
                }
                else if (objs[n] is System.Reflection.AssemblyProductAttribute)
                {
                    System.Reflection.AssemblyProductAttribute description = objs[n] as System.Reflection.AssemblyProductAttribute;
                    ApplicationName.Text = description.Product;
                }
            }
            // Set focus on the okay button
            OkayButton.Focus();
        }
        // On Okay, close the dialog.
        private void OnOK(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
