/*======================================================================

	Barcode_Sample_MFC - Hand Held Imager Barcode Sample (MFC based)

	UNLESS OTHER WISE AGREED TO BY HONEYWELL INTERNATIONAL AND THE USER 
    OF THIS CODE, THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT 
    WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT 
    LIMITED TO 	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS 
    FOR A 	PARTICULAR PURPOSE.

	COPYRIGHT (C) 2000-2008 HONEYWELL INTERNALTIONAL, Inc.

	THIS SOFTWARE IS PROTECTED BY COPYRIGHT LAWS OF THE UNITED STATES OF 
	AMERICA AND OF FOREIGN COUNTRIES. THIS SOFTWARE IS FURNISHED UNDER A 
	LICENSE AND/OR A NONDISCLOSURE AGREEMENT AND MAY BE USED IN ACCORDANCE 
	WITH THE TERMS OF THOSE	AGREEMENTS. UNAUTHORIZED REPRODUCTION, 
	DUPLICATION OR DISTRIBUTION OF THIS SOFTWARE, OR ANY PORTION OF IT 
	WILL BE PROSECUTED TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.

	Module:		Barcode_Sample_MFCDlg.cpp
	
	Description: Class implementation file for the MFC dialog of the 
    Barcode Sample application.
				
======================================================================*/
// Barcode_Sample_MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Barcode_Sample_MFC.h"
#include "Barcode_Sample_MFCDlg.h"

bool SetSnapAndShipTrigger( bool bSet );

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
// CBarcode_Sample_MFCDlg dialog
CBarcode_Sample_MFCDlg::CBarcode_Sample_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBarcode_Sample_MFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBarcode_Sample_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_FEEDBACK, ctlFeedback);
    DDX_Control(pDX, IDC_DATA, ctlData);
    DDX_Control(pDX, IDC_COMM, ctrl_CEdit_Comm);
}

BEGIN_MESSAGE_MAP(CBarcode_Sample_MFCDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(ID_CONNECT, &CBarcode_Sample_MFCDlg::OnBnClickedConnect)
    ON_BN_CLICKED(ID_CAPTURE_BARCODE, &CBarcode_Sample_MFCDlg::OnBnClickedCaptureBarcode)
    ON_BN_CLICKED(ID_DISCONNECT, &CBarcode_Sample_MFCDlg::OnBnClickedDisconnect)
    ON_BN_CLICKED(ID_ASYNC_BARCODE_CAPTURE, &CBarcode_Sample_MFCDlg::OnBnClickedAsyncBarcodeCapture)
    ON_MESSAGE( WM_HHI_EVENT_HWND_MSG,OnEventHwndMsg )
END_MESSAGE_MAP()


// CBarcode_Sample_MFCDlg message handlers

BOOL CBarcode_Sample_MFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    ctrl_CEdit_Comm.SetWindowTextA("1");
    ctlFeedback.SetWindowTextA("First set the port number.");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBarcode_Sample_MFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBarcode_Sample_MFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBarcode_Sample_MFCDlg::OnBnClickedConnect()
{
    // Setup working vars
    Result_t Connected;
    bool     bKeepGoing = true;

    // Give feedback that we are attempting to make a connection
    ctlFeedback.SetWindowTextA("Attempting to connect...");

    // Setup the port configuration structure
    HHI_SERIAL_PORT_CONFIG  PortConfig;
    PortConfig.baudRate     = SERIAL_BAUD_115200;
    PortConfig.bAutoBaud    = FALSE;
    PortConfig.dataBits     = SERIAL_DATA_BITS_8;
    PortConfig.dwStructSize = sizeof( HHI_SERIAL_PORT_CONFIG );
    PortConfig.parity       = SERIAL_PARITY_NONE;
    PortConfig.stopBits     = SERIAL_ONE_STOPBITS;

    // Build up the comm port name. Start by converting the text to an integer.
    char CommStr [20];
    char CommNumber [5];
    int  i;
    ctrl_CEdit_Comm.GetWindowTextA(CommNumber, 5);
    if(EOF == sscanf_s(CommNumber, "%d", &i))
    {
      bKeepGoing = false;
    }

    // Using the integer decide if we need to prefix the name with \\.\
    // then add the COM and port number
    if(bKeepGoing)
    {
        strcpy_s(CommStr,"");
        if(i > 9)  // This is a windows peculiarity for comm ports above 9.
            strcpy_s(CommStr,"\\\\.\\");
            
            
        if( 0 == strcat_s(CommStr, "COM"))
        {
            sprintf_s(CommNumber,"%i\0", i);
            if( 0 != strcat_s(CommStr, CommNumber))
                bKeepGoing = false;
        }
        else
        {
            bKeepGoing = false;
        }
    }

    // Now try to connect.
    if(bKeepGoing)
    {
        try
        {
            Connected = hhiNamedConnect(CommStr, &PortConfig);
        }
        catch(...)
        {
            Connected = RESULT_ERR_NOTCONNECTED;
            ctlFeedback.SetWindowTextA("Failed to make a connection.");
        }
    }


    // If we have a good result code, let's test the connection
    if((Connected == RESULT_SUCCESS) && (bKeepGoing))
    {
        if(hhiEngineConnected())
        {
            ctlFeedback.SetWindowTextA("Successfully Connected!!");
            GetDlgItem(ID_CAPTURE_BARCODE)->EnableWindow(TRUE);
            GetDlgItem(ID_DISCONNECT)->EnableWindow(TRUE);
            GetDlgItem(ID_CONNECT)->EnableWindow(FALSE);
            GetDlgItem(ID_ASYNC_BARCODE_CAPTURE)->EnableWindow(TRUE);
        }
        else
            ctlFeedback.SetWindowTextA("Not connected!");

    }
    else
    {
        ctlFeedback.SetWindowTextA(ErrorMessage(Connected));
    }
}

void CBarcode_Sample_MFCDlg::OnBnClickedCaptureBarcode()
{
    // Setup working vars
    Result_t rtResult;
    
    // Setup the structure needed to return the barcode data in.
    // Fill it's structure size property
    HHI_DECODE_MSG  decodeMsg;
    decodeMsg.dwStructSize = sizeof( HHI_DECODE_MSG );

    // Go capture a barcode
    try
    {
        ctlFeedback.SetWindowTextA("Attempting to read a barcode...");
        rtResult = hhiCaptureBarcode(&decodeMsg, 100, TRUE);
    }
    catch(...)
    {
        rtResult = RESULT_ERR_NODECODE;
    }
        

    // Set what data we catured to the user interface or clear it 
    // if no data was captured.
    if(RESULT_SUCCESS == rtResult)
    {
        ctlData.SetWindowTextA(decodeMsg.pchMessage);
    }
    else
    {
        ctlData.SetWindowTextA("");
    }

    // Show what the result code was
    ctlFeedback.SetWindowTextA(ErrorMessage(rtResult));
}

void CBarcode_Sample_MFCDlg::OnBnClickedAsyncBarcodeCapture()
{
    // Give some feeback
    ctlFeedback.SetWindowTextA("Now point the scanner at a barcode and pull the trigger.");
    hhiSetAsyncMethods( NULL,GetSafeHwnd(),NULL );
    SetSnapAndShipTrigger(false);
    
}

void CBarcode_Sample_MFCDlg::OnBnClickedDisconnect()
{
    // Disconnect the scanner
    Result_t result = hhiDisconnect();

    // If we were successful, post a message saying so.
    // Enable the "Connect" button and disable the 
    // "Capture Barcode" and "Disconnect" buttons.
    if(RESULT_SUCCESS == result)
    {
        // Give feedback and button states
        ctlFeedback.SetWindowTextA("Scanner Disconnected.");
        GetDlgItem(ID_CAPTURE_BARCODE)->EnableWindow(FALSE);
        GetDlgItem(ID_DISCONNECT)->EnableWindow(FALSE);
        GetDlgItem(ID_ASYNC_BARCODE_CAPTURE)->EnableWindow(FALSE);
        GetDlgItem(ID_CONNECT)->EnableWindow(TRUE);
    }

    // Else we were not successful.  Post the error message.
    else
    {
        ctlFeedback.SetWindowTextA(ErrorMessage(result));
    }
}

bool SetSnapAndShipTrigger( bool bSet )
///////////////////////////////////////////////////////////////
// Purpose: Set the scanner to ship and image or a barcode
//          false = Barcode;  true = Image
///////////////////////////////////////////////////////////////
{
    HHI_TRIGGER trigger;

    trigger.dwStructSize = sizeof( HHI_TRIGGER );
    trigger.dwMask = TRGMASK_TRIG_MODE;
    trigger.TriggerMode = ( bSet ) ? HHI_SNAP_AND_SHIP : HHI_MANUAL_SERIAL;

    // Note: Setting FALSE means that the write if RAM only, TRUE would cause the value to be written to flash.
    bool bRetVal =  ( hhiWriteConfigItem( TRIGGER_CONFIG,&trigger,FALSE ) == RESULT_SUCCESS ) ? true : false;
    
    return( bRetVal );
} 

LRESULT CBarcode_Sample_MFCDlg::OnEventHwndMsg( WPARAM eventType,LPARAM dwBytes )
{
    Result_t       nResult = RESULT_ERR_NODECODE;

    // Barcode Event.
    if( (HHI_EVENT_TYPE)eventType == HHI_BARCODE_EVENT )
    {
        HHI_EVENT_TYPE   eventType;
        HHI_DECODE_MSG   decodeMsg;
        decodeMsg.dwStructSize = sizeof( HHI_DECODE_MSG );
        if(RESULT_SUCCESS == hhiGetAsyncResult( &eventType, &decodeMsg ))
        {
            ctlFeedback.SetWindowTextA("Barcode Received.");
            ctlData.SetWindowTextA((LPCTSTR)decodeMsg.pchMessage);
        }
        else
        {
            ctlFeedback.SetWindowTextA("Barcode event failed to supply data.");
        
        }
    }

    return( 0 );
}


LPCTSTR CBarcode_Sample_MFCDlg:: ErrorMessage(Result_t errorCode)
///////////////////////////////////////////////////////////////
// Purpose: To convert the Result_t error code to a string.
///////////////////////////////////////////////////////////////
{
    switch(errorCode)
    {
    case -1:
        return "INITIALIZE";
    case 0:
        return "SUCCESS";
    case 1:
        return "BAD FILE NAME";
    case 2:
        return "BAD PORT";
    case 3:
        return "BAD REGION";
    case 4:
        return "DRIVER";
    case 5:
        return "ENGINE BUSY";
    case 6:
        return "FILE";
    case 7:
        return "FILE IN COMPATIBLE";
    case 8:
        return "FILE INVALID";
    case 9:
        return "MEMORY";
    case 10:
        return "NO DECODE";
    case 11:
        return "NO DRIVER";
    case 12:
        return "NO IMAGE";
    case 13:
        return "NO RESPONSE";
    case 14:
        return "NOT CONNECTED";
    case 15:
        return "PARAMETER";
    case 16:
        return "UNSUPPORTED";
    case 17:
        return "UPGRADE";
    case 18:
        return "MENU DECODE";
    case 19:
        return "REFLASH";
    case 20:
        return "NO TRIGGER";
    case 21:
        return "BAD SMART IMAGE";
    case 22:
        return "SMART IMAGE TOO LARGE";
    case 23:
        return "BUFFER TOO SMALL";
    case 256:
        return "RESULT EOT";
    case 257:
        return "READ THREAD START";
    case 258:
        return "READ THREAD STOP";
    case 259:
        return "POLL EVENT";
    case 260:
        return "WRONG RESULT STRUCT";
    case 261:
        return "USER CANCEL";
    case 262:
        return "NAK";
    case 263:
        return "COMPRESSION FAILED";
    case 264:
        return "DECOMPRESSION FAILED";
    case 265:
        return "CAPTURE IMAGE FAILED";
    case 266:
        return "SHIP IMAGE FAILED";
    case 267:
        return "CONNECT BOOT CODE";
    case 268:
        return "BAUD TO HIGH";
    case 269:
        return "INVALID COMM PARAMS";
    case 270:
        return "UNICODE UNSUPPORTED";
    case 271:
        return "INTERNAL ERROR";
    case 272:
        return "NO INTEL BARCODE";
    case 273:
        return "BAD INTEL IMAGE";
    case 274:
        return "NOINTELIMAGE";
    case 275:
        return "DLL FILE";
    case 276:
        return "DECODER INIT FAILED";
    case 277:
        return "IMAGE PROCESSING FAILED";
    case 278:
        return "UNSUPPORTED ENGINE";
    case 279:
        return "SYMBOLOGY HAS NO RANGE";
    case 280:
        return "COMMUNICATIONS ERROR";
    }
    return "";
}

