/*======================================================================

	CIQ_Imaging_Sample_MFCDlg - Hand Held Imager Intelligent Image Capture 
    Sample (MFC based)

	UNLESS OTHER WISE AGREED TO BY HONEYWELL INTERNATIONAL AND THE USER 
    OF THIS CODE, THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT 
    WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT 
    LIMITED TO 	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS 
    FOR A 	PARTICULAR PURPOSE.

	COPYRIGHT (C) 2000-2008 HONEYWELL INTERNALTIONAL, Inc.

	THIS SOFTWARE IS PROTECTED BY COPYRIGHT LAWS OF THE UNITED STATES OF 
	AMERICA AND OF FOREIGN COUNTRIES. THIS SOFTWARE IS FURNISHED UNDER A 
	LICENSE AND/OR A NONDISCLOSURE AGREEMENT AND MAY BE USED IN ACCORDANCE 
	WITH THE TERMS OF THOSE	AGREEMENTS. UNAUTHORIZED REPRODUCTION, 
	DUPLICATION OR DISTRIBUTION OF THIS SOFTWARE, OR ANY PORTION OF IT 
	WILL BE PROSECUTED TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.

	Module:		 CIQ_Imaging_Sample_MFCDlg.cpp
	
	Description: Class implementation file for the application dialog 
    class of the HHI Intelligent Image Capture Sample.
				
======================================================================*/
// IQ_Imaging_Sample_MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IQ_Imaging_Sample_MFC.h"
#include "IQ_Imaging_Sample_MFCDlg.h"
#include <hhiImgrSdk.h>
#include "IQ_Imaging_Sample_MFC_Settings_Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MENU_HEIGHT     26;

HHI_INTEL_IMG   intelImageStruct;

// CIQ_Imaging_Sample_MFCDlg dialog
CIQ_Imaging_Sample_MFCDlg::CIQ_Imaging_Sample_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIQ_Imaging_Sample_MFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    // Initialize the IQ Image Settings.
    intelImageStruct.dwStructSize   = sizeof(intelImageStruct);
    intelImageStruct.bSendBinary    = FALSE;
    intelImageStruct.dwAspectRatio  = 40;
    intelImageStruct.dwHeight       = 80;
    intelImageStruct.dwWidth        = 180;
    intelImageStruct.maxImgSize.cx  = 200;
    intelImageStruct.maxImgSize.cy  = 200;
    intelImageStruct.nOffsetX       = 0;
    intelImageStruct.nOffsetY       = 50;
}

void CIQ_Imaging_Sample_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_FEEDBACK, ctlFeedback);
    DDX_Control(pDX, IDC_COMM, ctrl_CEdit_Comm);
}

BEGIN_MESSAGE_MAP(CIQ_Imaging_Sample_MFCDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(ID_CONNECT, &CIQ_Imaging_Sample_MFCDlg::OnBnClickedConnect)
    ON_BN_CLICKED(ID_CAPTURE_IMAGE, &CIQ_Imaging_Sample_MFCDlg::OnBnClickedCaptureImage)
    ON_BN_CLICKED(ID_DISCONNECT, &CIQ_Imaging_Sample_MFCDlg::OnBnClickedDisconnect)
    ON_BN_CLICKED(ID_IQIMAGE_SETTINGS, &CIQ_Imaging_Sample_MFCDlg::OnBnClickedIqimageSettings)
END_MESSAGE_MAP()


// CIQ_Imaging_Sample_MFCDlg message handlers

BOOL CIQ_Imaging_Sample_MFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    ctrl_CEdit_Comm.SetWindowTextA("1");
    m_bBitmapAvailable = FALSE;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIQ_Imaging_Sample_MFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

        // Clear the form
	    CClientDC dc(this); // device context for painting
		CRect rect;
		GetClientRect(&rect);
        rect.bottom = rect.bottom / 2;
        CBrush Brush;
        BOOL bResult = Brush.CreateSolidBrush(GetBkColor(dc.m_hDC));
        dc.FillRect(&rect, &Brush);


        // Draw the bitmap if we have one available
        if(m_bBitmapAvailable)
        {
            DrawBitmap(&dc);
        }

	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIQ_Imaging_Sample_MFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CIQ_Imaging_Sample_MFCDlg::OnBnClickedConnect()
{
    // Setup working vars
    Result_t Connected;
    bool     bKeepGoing = true;

    // Give feedback that we are attempting to make a connection
    ctlFeedback.SetWindowTextA("Attempting to connect...");

    // Setup the port configuration structure
    HHI_SERIAL_PORT_CONFIG  PortConfig;
    PortConfig.baudRate     = SERIAL_BAUD_115200;
    PortConfig.bAutoBaud    = FALSE;
    PortConfig.dataBits     = SERIAL_DATA_BITS_8;
    PortConfig.dwStructSize = sizeof( HHI_SERIAL_PORT_CONFIG );
    PortConfig.parity       = SERIAL_PARITY_NONE;
    PortConfig.stopBits     = SERIAL_ONE_STOPBITS;

    // Build up the comm port name.  We are assuming they only put
    // a number in the edit box.  We are not doing any error checking
    char CommStr [20];
    char CommNumber [5];
    int  i;
    ctrl_CEdit_Comm.GetWindowTextA(CommNumber, 5);
    if(EOF == sscanf_s(CommNumber, "%d", &i))
    {
      bKeepGoing = false;
    }

    // Using the integer decide if we need to prefix the name with \\.\
    // then add the COM and port number
    if(bKeepGoing)
    {
        strcpy_s(CommStr,"");
        if(i > 9)  // This is a windows peculiarity for comm ports above 9.
            strcpy_s(CommStr,"\\\\.\\");
            
            
        if( 0 == strcat_s(CommStr, "COM"))
        {
            sprintf_s(CommNumber,"%i\0", i);
            if( 0 != strcat_s(CommStr, CommNumber))
                bKeepGoing = false;
        }
        else
        {
            bKeepGoing = false;
        }
    }


    // Now try to connect
    if(bKeepGoing)
    {
        try
        {
            Connected = hhiNamedConnect(CommStr, &PortConfig);
        }
        catch(...)
        {
            Connected = RESULT_ERR_NOTCONNECTED;
            ctlFeedback.SetWindowTextA("Failed to make a connection.");
        }
    }

    // If we have a good result code, let's test the connection
    if((Connected == RESULT_SUCCESS)&&(bKeepGoing))
    {
        if(hhiEngineConnected())
        {
            ctlFeedback.SetWindowTextA("Successfully Connected!!");
            GetDlgItem(ID_CAPTURE_IMAGE)->EnableWindow(TRUE);
            GetDlgItem(ID_DISCONNECT)->EnableWindow(TRUE);
            GetDlgItem(ID_CONNECT)->EnableWindow(FALSE);
        }
        else
            ctlFeedback.SetWindowTextA("Not connected!");

    }
    else
    {
        ctlFeedback.SetWindowTextA(ErrorMessage(Connected));
    }
}

LPCTSTR CIQ_Imaging_Sample_MFCDlg:: ErrorMessage(Result_t errorCode)
///////////////////////////////////////////////////////////////
// Purpose: To convert the Result_t error code to a string.
///////////////////////////////////////////////////////////////
{
    switch(errorCode)
    {
    case -1:
        return "INITIALIZE";
    case 0:
        return "SUCCESS";
    case 1:
        return "BAD FILE NAME";
    case 2:
        return "BAD PORT";
    case 3:
        return "BAD REGION";
    case 4:
        return "DRIVER";
    case 5:
        return "ENGINE BUSY";
    case 6:
        return "FILE";
    case 7:
        return "FILE IN COMPATIBLE";
    case 8:
        return "FILE INVALID";
    case 9:
        return "MEMORY";
    case 10:
        return "NO DECODE";
    case 11:
        return "NO DRIVER";
    case 12:
        return "NO IMAGE";
    case 13:
        return "NO RESPONSE";
    case 14:
        return "NOT CONNECTED";
    case 15:
        return "PARAMETER";
    case 16:
        return "UNSUPPORTED";
    case 17:
        return "UPGRADE";
    case 18:
        return "MENU DECODE";
    case 19:
        return "REFLASH";
    case 20:
        return "NO TRIGGER";
    case 21:
        return "BAD SMART IMAGE";
    case 22:
        return "SMART IMAGE TOO LARGE";
    case 23:
        return "BUFFER TOO SMALL";
    case 256:
        return "RESULT EOT";
    case 257:
        return "READ THREAD START";
    case 258:
        return "READ THREAD STOP";
    case 259:
        return "POLL EVENT";
    case 260:
        return "WRONG RESULT STRUCT";
    case 261:
        return "USER CANCEL";
    case 262:
        return "NAK";
    case 263:
        return "COMPRESSION FAILED";
    case 264:
        return "DECOMPRESSION FAILED";
    case 265:
        return "CAPTURE IMAGE FAILED";
    case 266:
        return "SHIP IMAGE FAILED";
    case 267:
        return "CONNECT BOOT CODE";
    case 268:
        return "BAUD TO HIGH";
    case 269:
        return "INVALID COMM PARAMS";
    case 270:
        return "UNICODE UNSUPPORTED";
    case 271:
        return "INTERNAL ERROR";
    case 272:
        return "NO INTEL BARCODE";
    case 273:
        return "BAD INTEL IMAGE";
    case 274:
        return "NOINTELIMAGE";
    case 275:
        return "DLL FILE";
    case 276:
        return "DECODER INIT FAILED";
    case 277:
        return "IMAGE PROCESSING FAILED";
    case 278:
        return "UNSUPPORTED ENGINE";
    case 279:
        return "SYMBOLOGY HAS NO RANGE";
    case 280:
        return "COMMUNICATIONS ERROR";
    }
    return "";
}

void CIQ_Imaging_Sample_MFCDlg::OnBnClickedCaptureImage()
{
    // Setup working vars
    HHI_RAW_DECODE_MSG  decodeMsg;
    HHI_IMAGER_CAPS     imgrCapsStruct;
    HHI_IMAGE           imageStruct;
    SIZE                imgSize;
    unsigned int        uiBufferSize;
    BOOL                bKeepGoing  = TRUE;
    Result_t            rtResult;

    // Capture what the imager is capable of.  We use this data
    // to figure out how big a buffer we need for images.
    if(bKeepGoing)
    {
        // Setup the structure to be used
        imgrCapsStruct.dwStructSize = sizeof(imgrCapsStruct);

        // Do the read
        try
        {
            ctlFeedback.SetWindowTextA("Getting Scanner Capabilites...");
            rtResult = hhiReadImagerCapabilities(&imgrCapsStruct);
        }
        catch(...)
        {
           rtResult = RESULT_ERR_CAPTURE_IMAGE_FAILED;
        }

        // Give Progress
        if(RESULT_SUCCESS == rtResult)
        {
            ctlFeedback.SetWindowTextA("Captured Capabilities.");
            imgSize = imgrCapsStruct.fullImgSize;
        }
        else
        {
            char szMessage [100];
            strcpy_s(szMessage, "Failure getting engine capablities.\r\n");
            strcat_s(szMessage, ErrorMessage(rtResult));
            ctlFeedback.SetWindowTextA(szMessage);
            bKeepGoing = FALSE;
        }
    }

    // Setup the structure needed to return the barcode data in.
    // Fill it's structure size property
    if(bKeepGoing)
    {
            decodeMsg.dwStructSize = sizeof(decodeMsg);
    }

    if(bKeepGoing)
    {
            // Calculate how big a buffer we need and create the buffer
            // Each pixel needs 8 bits to spell out its color and then the headers
            // take up an extra 1080 bytes 
            uiBufferSize = (imgSize.cx * imgSize.cy) + 1100; // extra space to allow bmp header
            m_pbyReceivedBitmap = new BYTE [uiBufferSize];

            // Maximum allowe size on our GUI is simply the client are width of the application
            // and the height of the client area above the comm port text box (minus 10 for separation).
            RECT    rect;   // Generic rectangle
            // Get the application client area.
            GetClientRect( &rect );
            // This is the maximum image width allowed;
            intelImageStruct.maxImgSize.cx = (rect.right - rect.left);
            // To calculate the height, get the top position of the app, subtract the height of the
            // menu (this gives the position of the top of the client area), then subtract the position
            // of the highest control which in this case is the comm port text box).
            GetWindowRect( &rect );
            // Top of application client area.
            LONG top = rect.top + MENU_HEIGHT;
            // Get the position of the comm port text box.
            GetDlgItem( IDC_COMM )->GetWindowRect( &rect );
            // Calculate the height of the area in between subtracting some for separation
            intelImageStruct.maxImgSize.cy  = (rect.top - top) - 10;

            // Setup the image buffer
            imageStruct.dwJpegQFactor       = 60;
            imageStruct.dwStructSize        = sizeof(imageStruct);
            imageStruct.fileFormat          = FF_BMP_GRAY;
            imageStruct.imgSize.cx          = 150;
            imageStruct.imgSize.cy          = 30;
            imageStruct.nBufferSize         = uiBufferSize;
            imageStruct.nBytesReturned      = 0;
            imageStruct.nExposureTime       = 0;
            imageStruct.nGain               = 0;
            imageStruct.puchBuffer          = m_pbyReceivedBitmap;
    }

    // Attempt to do an IQ Image capture
    if(bKeepGoing)
    {
        try
        {
            // Reset if we have an image to show
            m_bBitmapAvailable = FALSE;

            // Attempt to get the image
            rtResult = hhiRawAcquireIntelligentImage(&intelImageStruct, &decodeMsg, 2, &imageStruct, TRUE);
            ctlFeedback.SetWindowTextA(ErrorMessage(rtResult));
            if(RESULT_SUCCESS == rtResult)
            {
                m_bBitmapAvailable = TRUE;
            }
        }
        catch(...)
        {
            rtResult = RESULT_ERR_CAPTURE_IMAGE_FAILED;
        }
    }

    // Force a repaint to draw what we have
    OnPaint();
}

void CIQ_Imaging_Sample_MFCDlg::OnBnClickedDisconnect()
{
    // Disconnect the scanner
    Result_t result = hhiDisconnect();

    // If we were successful, post a message saying so.
    // Enable the "Connect" button and disable the 
    // "Capture Image" and "Disconnect" buttons.
    if(RESULT_SUCCESS == result)
    {
        ctlFeedback.SetWindowTextA("Scanner Disconnected.");
        GetDlgItem(ID_CAPTURE_IMAGE)->EnableWindow(FALSE);
        GetDlgItem(ID_DISCONNECT)->EnableWindow(FALSE);
        GetDlgItem(ID_CONNECT)->EnableWindow(TRUE);
    }

    // Else we were not successful.  Post the error message.
    else
    {
        ctlFeedback.SetWindowTextA(ErrorMessage(result));
    }
}

void CIQ_Imaging_Sample_MFCDlg::OnBnClickedIqimageSettings()
{
    CIntelImgDlg *pIntelDlg = new CIntelImgDlg();
    pIntelDlg->SetIntelImgStruct( &intelImageStruct );
    if( pIntelDlg->DoModal() == IDOK )
        pIntelDlg->GetIntelImgStruct( &intelImageStruct );
}

void CIQ_Imaging_Sample_MFCDlg::DrawBitmap(CDC* pDC )
{
    // Setup working vars
    BOOL    bKeepGoing;
    HBITMAP hbmImage;

    // Set pointers up to the bmp information we received
    PBITMAPFILEHEADER pBmpFileHeader = (PBITMAPFILEHEADER)m_pbyReceivedBitmap;
    PBITMAPINFOHEADER pBmpInfoHeader = (PBITMAPINFOHEADER)(m_pbyReceivedBitmap + sizeof(BITMAPFILEHEADER));
    PBITMAPINFO       pBmpInfo       = (PBITMAPINFO)pBmpInfoHeader;
    PVOID             pv             = NULL;         // Pointer to data buffer.

	// Create a compatible Device Context to the form we want to display on
    CDC compatibleDC;
    bKeepGoing = compatibleDC.CreateCompatibleDC(pDC);

    // Create a compatible bitmap
    if(bKeepGoing)
    {
        hbmImage = CreateDIBSection(
                   pDC->m_hDC,      // handle to DC
                   pBmpInfo,        // bitmap data
                   DIB_RGB_COLORS,  // data type indicator
                   &pv,             // bit values
                   NULL,            // handle to file mapping object
                   0);              // offset to bitmap bit values
    }
        
    // Copy the actual bitmap data from the received data into the compatible 
    // bitmap we just generated.  We find the length of the data, then where it
    // starts then copy it all in one big memory copy.
    if(bKeepGoing)
    {
        try
        {
            size_t uiLengthOfData = pBmpInfoHeader->biSizeImage;
            int    iOffset        = pBmpFileHeader->bfOffBits;
            void * pSource        = (void * )(m_pbyReceivedBitmap + iOffset);
            memcpy(pv, pSource, uiLengthOfData);
        }
        catch(...)
        {
            ctlFeedback.SetWindowTextA("Failed to copy the image data.");
        }
    }

    // Select the bitmap into the compatible device context
    if(bKeepGoing)
        HBITMAP hOldBmp = (HBITMAP)SelectObject( compatibleDC,hbmImage );

    // If you wish to do a straight copy....
    // do the bitblt copying the compatible device context into the visible one
    //bResult = pDC->BitBlt(5,5,pBmpInfoHeader->biWidth,pBmpInfoHeader->biHeight,&compatibleDC, 0, 0, SRCCOPY);

    // This is to allow us to stretch the image to match the form width
    // that we are drawing on.
    if(bKeepGoing)
    {

        RECT cdAreaRect;
        GetClientRect(&cdAreaRect);
        float fMultiplier = (float) cdAreaRect.right / (float)pBmpInfoHeader->biWidth;

        CPen tmpPen;
        tmpPen.CreatePen(PS_SOLID, 100, RGB(0,0,0));
        pDC->MoveTo(0, (int)(pBmpInfoHeader->biHeight * fMultiplier));
        pDC->LineTo(cdAreaRect.right, (int)(pBmpInfoHeader->biHeight * fMultiplier));
        try
        {
            //pDC->Rectangle( 0,0,intelImageStruct.maxImgSize.cx,intelImageStruct.maxImgSize.cy );
            bKeepGoing = pDC->StretchBlt(  0, 
                                        0,
                                        cdAreaRect.right, 
                                        (int)(pBmpInfoHeader->biHeight * fMultiplier),
                                        &compatibleDC,
                                        0,
                                        0,
                                        pBmpInfoHeader->biWidth,
                                        pBmpInfoHeader->biHeight,
                                        SRCCOPY);
        }
        catch(...)
        {
            ctlFeedback.SetWindowTextA("Failed to bitblt the image.");
        }
    }
    
} // End CreateImageBitmap()

