/*
******************************************************************************
*
*   UNLESS OTHER WISE AGREED TO BY HONEYWELL INTERNATIONAL AND THE USER 
*   OF THIS CODE, THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT 
*   WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT 
*   LIMITED TO 	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS 
*   FOR A 	PARTICULAR PURPOSE.
*   
*   COPYRIGHT (C) 2000-2008 HONEYWELL INTERNALTIONAL, Inc.
*   
*   THIS SOFTWARE IS PROTECTED BY COPYRIGHT LAWS OF THE UNITED STATES OF 
*   AMERICA AND OF FOREIGN COUNTRIES. THIS SOFTWARE IS FURNISHED UNDER A 
*   LICENSE AND/OR A NONDISCLOSURE AGREEMENT AND MAY BE USED IN ACCORDANCE 
*   WITH THE TERMS OF THOSE	AGREEMENTS. UNAUTHORIZED REPRODUCTION, 
*   DUPLICATION OR DISTRIBUTION OF THIS SOFTWARE, OR ANY PORTION OF IT 
*   WILL BE PROSECUTED TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.
*
******************************************************************************
*
* $RCSfile: IQ_Imaging_Sample_MFC/IQ_Imaging_Sample_MFC_Settings_Dlg.h $
* $Revision: 1.2 $
* $Date: 2009/09/21 09:13:55EDT $
* $Author: Haile, Adam Michael (E412723) $
*
*  File:        Inelimgdlg.h
*
*  Description: Header file which contains the class declarations for class
*               CIntelImgDlg.  This class contains the functionality for the
*               Intelligent Imaging Setup dialog.
*
*  Rev. Date    By     Revision Notes
*  ----------   ---    ----------------
*  01/13/2003   JCM    Original Release
*
******************************************************************************
*/

#if !defined(AFX_INTELIMGDLG_H__A95D7BD4_03BF_4D05_A4DF_E33588C72FD9__INCLUDED_)
#define AFX_INTELIMGDLG_H__A95D7BD4_03BF_4D05_A4DF_E33588C72FD9__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// IntelImgDlg.h : header file
//
#include "hhiImgrSdk.h"
/////////////////////////////////////////////////////////////////////////////
// CIntelImgDlg dialog

class CIntelImgDlg : public CDialog
{
// Construction
public:
	CIntelImgDlg(CWnd* pParent = NULL);   // standard constructor

    BOOL SetIntelImgStruct( PHHI_INTEL_IMG pIntelImg ); // Initialize member intelligent imaging struct
    BOOL GetIntelImgStruct( PHHI_INTEL_IMG pIntelImg ); // Retrieve member intelligent imaging struct

// Dialog Data
	//{{AFX_DATA(CIntelImgDlg)
	enum { IDD = IDD_INTEL_IMAGE_DLG };
	CSpinButtonCtrl	m_offsetYSpin;
	CSpinButtonCtrl	m_offsetXSpin;
	CSpinButtonCtrl	m_widthSpin;
	CSpinButtonCtrl	m_heightSpin;
	CSpinButtonCtrl	m_aspectRatioSpin;
	UINT	m_uAspectRatio;
	UINT	m_uHeight;
	UINT	m_uWidth;
	long	m_nOffsetX;
	long	m_nOffsetY;
	BOOL	m_bBinaryImage;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIntelImgDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CIntelImgDlg)
	afx_msg void OnIntelimgApply();
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	virtual void OnOK();
	afx_msg void OnAztecValues();
	afx_msg void OnCode39Values();
	afx_msg void OnChangeIntelimgItem();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    HHI_INTEL_IMG   m_intelImg;     // Member intelligent imaging struct

    BOOL m_bInitialized;            // Dialog controls have been created
    BOOL m_bApplied;                // User has modified and accepted changed values.
    BOOL m_bChangesValid;           // Values are valid.

    BOOL ItemsChanged( void );      // Are control values different than current in m_intelImg?
    void ReadControlValues( void ); // Save values in control to m_intelImg.
    void UpdateButtonStates( void );
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INTELIMGDLG_H__A95D7BD4_03BF_4D05_A4DF_E33588C72FD9__INCLUDED_)

//=================================================================
// $Log: IQ_Imaging_Sample_MFC/IQ_Imaging_Sample_MFC_Settings_Dlg.h  $
// Revision 1.2 2009/09/21 09:13:55EDT Haile, Adam Michael (E412723) 
//  
// Revision 1.1 2008/06/20 10:22:32EDT MontoroJ 
// Initial revision
// Member added to project d:/MKS_ES/ES/HHIDevSDK/HHI Imager SDK/Samples/IQ_Imaging_Sample_MFC/IQ_Imaging_Sample_MFC.pj
// Revision 1.2 2007/05/24 16:17:49EDT MontoroJ 
// - Rebranded to hhi from mat or hhp.
// Revision 1.2 2005/11/07 10:12:52EST MontoroJ 
// - Modified dialog behavior as follows:
//   - Apply button is only enabled if displayed items different from last apply (or values at
//     start)
//   - Aztec Demo and Code39 demo buttons are enabled as long as displayed items do not
//     match the values that would be set by that button.
// Revision 1.1 2003/06/19 11:54:18EDT holzhaud 
// Initial revision
// Member added to project d:/MKS_IT/SDK/Matrix_SDK_Examples/Matrix_SDK_Examples.pj
// Revision 1.5 2003/05/19 10:55:15EDT montoroj 
// - Fixed bug where it was possible to exit the dialog saving invalid data.
// Revision 1.4 2003/03/12 14:23:00EST montoroj 
// - Added code to support sending and setting of bits per pixel for intelligent image
//   transfer.
// Revision 1.3 2003/02/20 16:28:46EST montoroj 
// - Dumbo had put $LOG$ instead of $Log: IQ_Imaging_Sample_MFC/IQ_Imaging_Sample_MFC_Settings_Dlg.h  $
// - Dumbo had put Revision 1.2 2009/09/21 09:13:55EDT Haile, Adam Michael (E412723) 
// - Dumbo had put  
// - Dumbo had put Revision 1.1 2008/06/20 10:22:32EDT MontoroJ 
// - Dumbo had put Initial revision
// - Dumbo had put Member added to project d:/MKS_ES/ES/HHIDevSDK/HHI Imager SDK/Samples/IQ_Imaging_Sample_MFC/IQ_Imaging_Sample_MFC.pj
// - Dumbo had put Revision 1.2 2007/05/24 16:17:49EDT MontoroJ 
// - Dumbo had put - Rebranded to hhi from mat or hhp.
// - Dumbo had put Revision 1.2 2005/11/07 10:12:52EST MontoroJ 
// - Dumbo had put - Modified dialog behavior as follows:
// - Dumbo had put   - Apply button is only enabled if displayed items different from last apply (or values at
// - Dumbo had put     start)
// - Dumbo had put   - Aztec Demo and Code39 demo buttons are enabled as long as displayed items do not
// - Dumbo had put     match the values that would be set by that button.
// - Dumbo had put Revision 1.1 2003/06/19 11:54:18EDT holzhaud 
// - Dumbo had put Initial revision
// - Dumbo had put Member added to project d:/MKS_IT/SDK/Matrix_SDK_Examples/Matrix_SDK_Examples.pj
// - Dumbo had put Revision 1.5 2003/05/19 10:55:15EDT montoroj 
// - Dumbo had put - Fixed bug where it was possible to exit the dialog saving invalid data.
// - Dumbo had put Revision 1.4 2003/03/12 14:23:00EST montoroj 
// - Dumbo had put - Added code to support sending and setting of bits per pixel for intelligent image
// - Dumbo had put   transfer.
//=================================================================
