/*======================================================================

	Image_Capture_Sample_MFC - Hand Held Imager Image Capture Sample (MFC 
    based)

	UNLESS OTHER WISE AGREED TO BY HONEYWELL INTERNATIONAL AND THE USER 
    OF THIS CODE, THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT 
    WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT 
    LIMITED TO 	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS 
    FOR A 	PARTICULAR PURPOSE.

	COPYRIGHT (C) 2000-2008 HONEYWELL INTERNALTIONAL, Inc.

	THIS SOFTWARE IS PROTECTED BY COPYRIGHT LAWS OF THE UNITED STATES OF 
	AMERICA AND OF FOREIGN COUNTRIES. THIS SOFTWARE IS FURNISHED UNDER A 
	LICENSE AND/OR A NONDISCLOSURE AGREEMENT AND MAY BE USED IN ACCORDANCE 
	WITH THE TERMS OF THOSE	AGREEMENTS. UNAUTHORIZED REPRODUCTION, 
	DUPLICATION OR DISTRIBUTION OF THIS SOFTWARE, OR ANY PORTION OF IT 
	WILL BE PROSECUTED TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.

	Module:		 Image_Capture_Sample_MFCDlg.cpp
	
	Description: Class implementation file for the MFC dialog of the 
    Image Capture Sample application.
				
======================================================================*/
// Image_Capture_Sample_MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Image_Capture_Sample_MFC.h"
#include "Image_Capture_Sample_MFCDlg.h"
#include "hhiImgrSdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
// CImage_Capture_Sample_MFCDlg dialog
CImage_Capture_Sample_MFCDlg::CImage_Capture_Sample_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImage_Capture_Sample_MFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImage_Capture_Sample_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_FEEDBACK, ctlFeedback);
    DDX_Control(pDX, IDC_COMM, ctrl_CEdit_Comm);
}

CImage_Capture_Sample_MFCDlg::~CImage_Capture_Sample_MFCDlg()
{
    if( ::hhiEngineConnected() )
    {
        // Put the image back into scan and ship mode.
        SetSnapAndShipTrigger( false );
        // Delete the current received bitmap.
        if( m_pbyReceivedBitmap != NULL )
        {
            m_uiBufferSize = 0;
            delete [] m_pbyReceivedBitmap;
        }
    }
}

BEGIN_MESSAGE_MAP(CImage_Capture_Sample_MFCDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(ID_CONNECT, &CImage_Capture_Sample_MFCDlg::OnBnClickedConnect)
    ON_BN_CLICKED(ID_DISCONNECT, &CImage_Capture_Sample_MFCDlg::OnBnClickedDisconnect)
    ON_BN_CLICKED(ID_CAPTURE_IMAGE, &CImage_Capture_Sample_MFCDlg::OnBnClickedCaptureImage)
    ON_BN_CLICKED(ID_ASYNC_CAPTURE_IMAGE, &CImage_Capture_Sample_MFCDlg::OnBnClickedAsyncCaptureImage)
    ON_MESSAGE( WM_HHI_EVENT_HWND_MSG,OnEventHwndMsg )
END_MESSAGE_MAP()


// CImage_Capture_Sample_MFCDlg message handlers

bool CImage_Capture_Sample_MFCDlg::SetSnapAndShipTrigger( bool bSet )
///////////////////////////////////////////////////////////////
// Purpose: Set the scanner to ship and image or a barcode
//          false = Barcode;  true = Image
///////////////////////////////////////////////////////////////
{
    HHI_TRIGGER trigger;

    trigger.dwStructSize = sizeof( HHI_TRIGGER );
    trigger.dwMask = TRGMASK_TRIG_MODE;
    trigger.TriggerMode = ( bSet ) ? HHI_SNAP_AND_SHIP : HHI_MANUAL_SERIAL;

    // Note: Setting FALSE means that the write if RAM only, TRUE would cause the value to be written to flash.
    bool bRetVal =  ( hhiWriteConfigItem( TRIGGER_CONFIG,&trigger,FALSE ) == RESULT_SUCCESS ) ? true : false;
    
    return( bRetVal );
} 

BOOL CImage_Capture_Sample_MFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    ctrl_CEdit_Comm.SetWindowTextA("1");
    m_bBitmapAvailable = FALSE;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CImage_Capture_Sample_MFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

        // Draw the bitmap if we have one available
        if(m_bBitmapAvailable)
        {
		    CClientDC dc(this); // device context for painting
            DrawBitmap(&dc);
        }
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CImage_Capture_Sample_MFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CImage_Capture_Sample_MFCDlg::OnBnClickedConnect()
{
    // Setup working vars
    Result_t Connected;
    bool     bKeepGoing = true;

    // Give feedback that we are attempting to make a connection
    ctlFeedback.SetWindowTextA("Attempting to connect...");

    // Setup the port configuration structure
    HHI_SERIAL_PORT_CONFIG  PortConfig;
    PortConfig.baudRate     = SERIAL_BAUD_115200;
    PortConfig.bAutoBaud    = FALSE;
    PortConfig.dataBits     = SERIAL_DATA_BITS_8;
    PortConfig.dwStructSize = sizeof( HHI_SERIAL_PORT_CONFIG );
    PortConfig.parity       = SERIAL_PARITY_NONE;
    PortConfig.stopBits     = SERIAL_ONE_STOPBITS;

    // Build up the comm port name. Start by converting the text to an integer.
    char CommStr [20];
    char CommNumber [5];
    int  i;
    ctrl_CEdit_Comm.GetWindowTextA(CommNumber, 5);
    if(EOF == sscanf_s(CommNumber, "%d", &i))
    {
      bKeepGoing = false;
    }

    // Using the integer decide if we need to prefix the name with \\.\
    // then add the COM and port number
    if(bKeepGoing)
    {
        strcpy_s(CommStr,"");
        if(i > 9)  // This is a windows peculiarity for comm ports above 9.
            strcpy_s(CommStr,"\\\\.\\");
            
            
        if( 0 == strcat_s(CommStr, "COM"))
        {
            sprintf_s(CommNumber,"%i\0", i);
            if( 0 != strcat_s(CommStr, CommNumber))
                bKeepGoing = false;
        }
        else
        {
            bKeepGoing = false;
        }
    }

    // Now try to connect.
    if(bKeepGoing)
    {
        try
        {
            Connected = hhiNamedConnect(CommStr, &PortConfig);
        }
        catch(...)
        {
            Connected = RESULT_ERR_NOTCONNECTED;
            ctlFeedback.SetWindowTextA("Failed to make a connection.");
        }
    }


    // If we have a good result code, let's test the connection
    if((Connected == RESULT_SUCCESS) && (bKeepGoing))
    {
        if(hhiEngineConnected())
        {
            // Give feedback
            ctlFeedback.SetWindowTextA("Successfully Connected!!");
            
        }
        else
        {
            ctlFeedback.SetWindowTextA("Not connected!");
            bKeepGoing = false;
        }

    }
    
    // If we have a good connection.  Let's get imager information
    if(bKeepGoing)
    {
        // Get what the scanner is capable of doing
        if(GetScannerCapabilities())
        {
            // Calculate how big a buffer we need and create the buffer
            SIZE imagerSize = m_imgrCapsStruct.fullImgSize;
            
            m_uiBufferSize = ( imagerSize.cx * imagerSize.cy * 2 ); // extra space to allow bmp header
            m_pbyReceivedBitmap = new BYTE [m_uiBufferSize];

        }
        else
        {
            ctlFeedback.SetWindowTextA("Failed to get scanner information.");
            bKeepGoing = false;
        }
    }
    
    // Lastly if everything is ok, enable the buttons
    if(bKeepGoing)
    {
        GetDlgItem(ID_CAPTURE_IMAGE)->EnableWindow(TRUE);
        GetDlgItem(ID_ASYNC_CAPTURE_IMAGE)->EnableWindow(TRUE);
        GetDlgItem(ID_DISCONNECT)->EnableWindow(TRUE);
        GetDlgItem(ID_CONNECT)->EnableWindow(FALSE);
    }
}

LPCTSTR CImage_Capture_Sample_MFCDlg:: ErrorMessage(Result_t errorCode)
///////////////////////////////////////////////////////////////
// Purpose: To convert the Result_t error code to a string.
///////////////////////////////////////////////////////////////
{
    switch(errorCode)
    {
    case -1:
        return "INITIALIZE";
    case 0:
        return "SUCCESS";
    case 1:
        return "BAD FILE NAME";
    case 2:
        return "BAD PORT";
    case 3:
        return "BAD REGION";
    case 4:
        return "DRIVER";
    case 5:
        return "ENGINE BUSY";
    case 6:
        return "FILE";
    case 7:
        return "FILE IN COMPATIBLE";
    case 8:
        return "FILE INVALID";
    case 9:
        return "MEMORY";
    case 10:
        return "NO DECODE";
    case 11:
        return "NO DRIVER";
    case 12:
        return "NO IMAGE";
    case 13:
        return "NO RESPONSE";
    case 14:
        return "NOT CONNECTED";
    case 15:
        return "PARAMETER";
    case 16:
        return "UNSUPPORTED";
    case 17:
        return "UPGRADE";
    case 18:
        return "MENU DECODE";
    case 19:
        return "REFLASH";
    case 20:
        return "NO TRIGGER";
    case 21:
        return "BAD SMART IMAGE";
    case 22:
        return "SMART IMAGE TOO LARGE";
    case 23:
        return "BUFFER TOO SMALL";
    case 256:
        return "RESULT EOT";
    case 257:
        return "READ THREAD START";
    case 258:
        return "READ THREAD STOP";
    case 259:
        return "POLL EVENT";
    case 260:
        return "WRONG RESULT STRUCT";
    case 261:
        return "USER CANCEL";
    case 262:
        return "NAK";
    case 263:
        return "COMPRESSION FAILED";
    case 264:
        return "DECOMPRESSION FAILED";
    case 265:
        return "CAPTURE IMAGE FAILED";
    case 266:
        return "SHIP IMAGE FAILED";
    case 267:
        return "CONNECT BOOT CODE";
    case 268:
        return "BAUD TO HIGH";
    case 269:
        return "INVALID COMM PARAMS";
    case 270:
        return "UNICODE UNSUPPORTED";
    case 271:
        return "INTERNAL ERROR";
    case 272:
        return "NO INTEL BARCODE";
    case 273:
        return "BAD INTEL IMAGE";
    case 274:
        return "NOINTELIMAGE";
    case 275:
        return "DLL FILE";
    case 276:
        return "DECODER INIT FAILED";
    case 277:
        return "IMAGE PROCESSING FAILED";
    case 278:
        return "UNSUPPORTED ENGINE";
    case 279:
        return "SYMBOLOGY HAS NO RANGE";
    case 280:
        return "COMMUNICATIONS ERROR";
    }
    return "";
}

void CImage_Capture_Sample_MFCDlg::OnBnClickedDisconnect()
{
    if( ::hhiEngineConnected() )
    {
        // Put the image back into scan and ship mode.
        SetSnapAndShipTrigger( false );
        // Delete the current received bitmap.
        if( m_pbyReceivedBitmap != NULL )
        {
            m_uiBufferSize = 0;
            delete [] m_pbyReceivedBitmap;
        }

        // Disconnect the scanner
        Result_t result = hhiDisconnect();

        // If we were successful, post a message saying so.
        // Enable the "Connect" button and disable the 
        // "Capture Barcode" and "Disconnect" buttons.
        if(RESULT_SUCCESS == result)
        {
            ctlFeedback.SetWindowTextA("Scanner Disconnected.");
            GetDlgItem(ID_CAPTURE_IMAGE)->EnableWindow(FALSE);
            GetDlgItem(ID_ASYNC_CAPTURE_IMAGE)->EnableWindow(FALSE);
            GetDlgItem(ID_DISCONNECT)->EnableWindow(FALSE);
            GetDlgItem(ID_CONNECT)->EnableWindow(TRUE);
        }
        // Else we were not successful.  Post the error message.
        else
        {
            ctlFeedback.SetWindowTextA(ErrorMessage(result));
        }
    }
}

void CImage_Capture_Sample_MFCDlg::OnBnClickedCaptureImage()
{
    // Setup working vars
    Result_t            rtResult            = RESULT_INITIALIZE;
    BOOL                bKeepGoing          = TRUE;
    HHI_IMAGER_CAPS     imgrCapsStruct;
    HHI_IMAGE           imageStruct;
    HHI_IMAGE_TRANSFER  imgTrans;
    SIZE                imgSize;


    // Make sure our trigger mode is correct
    if(bKeepGoing)
    {
            bKeepGoing = SetSnapAndShipTrigger(false);
    }

    // Capture what the imager is capable of.  We use this data
    // to figure out how big a buffer we need for images.
    if(bKeepGoing)
    {
        // Setup the structure to be used
        imgrCapsStruct.dwStructSize = sizeof(imgrCapsStruct);

        // Do the read
        try
        {
            ctlFeedback.SetWindowTextA("Getting Scanner Capabilites...");
            rtResult = hhiReadImagerCapabilities(&imgrCapsStruct);
        }
        catch(...)
        {
           rtResult = RESULT_ERR_CAPTURE_IMAGE_FAILED;
        }

        // Give Progress
        if(RESULT_SUCCESS == rtResult)
        {
            ctlFeedback.SetWindowTextA("Captured Capabilities.");
            imgSize = imgrCapsStruct.fullImgSize;
        }
        else
        {
            char szMessage [100];
            strcpy_s(szMessage, "Failure getting engine capablities.\r\n");
            strcat_s(szMessage, ErrorMessage(rtResult));
            ctlFeedback.SetWindowTextA(szMessage);
            bKeepGoing = FALSE;
        }
    }

    // Setup the buffer needed to hold an image, then go get the image
    if(bKeepGoing)
    {
        // Calculate how big a buffer we need and create the buffer
        //SIZE imagerSize = m_imgrCapsStruct.fullImgSize;
        //uiBufferSize = (imagerSize.cx * imagerSize.cy * 8) + 2048; // extra space to allow bmp header
        //m_pbyReceivedBitmap = new BYTE [uiBufferSize];

        // Setup the image buffer
        imageStruct.dwJpegQFactor       = 100;
        imageStruct.dwStructSize        = sizeof(HHI_IMAGE);
        imageStruct.fileFormat          = FF_BMP_GRAY;
        imageStruct.nBufferSize         = m_uiBufferSize;
        imageStruct.nBytesReturned      = 0;
        imageStruct.nExposureTime       = 0;
        imageStruct.nGain               = 0;
        imageStruct.puchBuffer          = m_pbyReceivedBitmap;



		/*
        //Setup the image transfer information
        imgTrans.bAdaptiveTextFilter    = FALSE;
        imgTrans.bFlipImage             = FALSE;
        imgTrans.bHistogramStretch      = FALSE;
        imgTrans.bInfinityFilter        = FALSE;
        imgTrans.bNoiseFilter           = FALSE;
        imgTrans.bUnsharpenBrighten     = FALSE;
        imgTrans.compressionMode        = COMPRESSION_NONE;    // Compression_t
        imgTrans.dwBitsPerPixel         = 8;                    // 1, 8
        imgTrans.dwCompressionFactor    = 60;                   // 0-100
        imgTrans.dwEdgeEhancement       = 0;                    // 0-23
        imgTrans.dwGammaCorrection      = 0;                    // 0-1000
        imgTrans.dwMask                 = 0x2B | BOUNDING_RECTANGLE_MASK;
        imgTrans.dwStructSize           = sizeof(imgTrans);
        imgTrans.dwSubSample            = 3;                    // 1-10
        imgTrans.dwTextEnhancement      = 0;                    // 0-255
        imgTrans.hTransferNotifyHwnd    = NULL;
        imgTrans.pdwTransferPercent     = NULL;
		//imgTrans.boundingRect			= 
		RECT boundRect;
		boundRect.top = 0;
		boundRect.left = 0;
		boundRect.bottom = 479;
		boundRect.right = 751;
		imgTrans.boundingRect			= boundRect;
		*/

		imgTrans.dwStructSize = sizeof(imgTrans);
		imgTrans.dwMask = TRANSFER_MASK_ALL;
		hhiReadConfigItem(SETUP_TYPE_DEFAULT, IMAGE_TRANSFER, &imgTrans);

        // Go get the image
        try
        {
            ctlFeedback.SetWindowTextA("Attempting to capture an image...");
            rtResult = hhiAcquireImage(&imageStruct,&imgTrans,NULL,TRUE);
        }
        catch(...)
        {
            rtResult = RESULT_ERR_CAPTURE_IMAGE_FAILED;
        }

        // Give Progress
        if(RESULT_SUCCESS == rtResult)
        {
            char szMessage [100];
            char szNumber  [10];
            _ltoa_s(imageStruct.nBytesReturned, szNumber, 10, 10);
            strcpy_s(szMessage, "Captured Image.\r\n");
            strcat_s(szMessage, szNumber);
            strcat_s(szMessage, " Bytes of data.\r\n");
			_ltoa_s(imageStruct.imgSize.cx, szNumber, 10, 10);
			strcat_s(szMessage, szNumber);
			strcat_s(szMessage, ", ");
			_ltoa_s(imageStruct.imgSize.cy, szNumber, 10, 10);
			strcat_s(szMessage, szNumber);
            ctlFeedback.SetWindowTextA(szMessage);

            // Draw the bitmap
            m_bBitmapAvailable = TRUE;
            WriteBitmapFile(&imageStruct);
            OnPaint();
        }
        else
        {
            char szMessage [100];
            strcpy_s(szMessage, "Failure getting the image.\r\n");
            strcat_s(szMessage, ErrorMessage(rtResult));
            ctlFeedback.SetWindowTextA(szMessage);
            bKeepGoing = FALSE;
        }
    }
}


void CImage_Capture_Sample_MFCDlg::WriteBitmapFile( PHHI_IMAGE pImage )
{
    // Setup Working Vars
    HANDLE hFile;
    
    // Build up the path name for where to store the file.
    // The next several lines are used to retrieve the desktop locations
    // then we append the file name Example.bmp to it.
    char szFilename[100];
    CWnd* pcWndDesktop = GetDesktopWindow();
    HWND hWndDesktop = pcWndDesktop->m_hWnd;
    LPITEMIDLIST pidlItem = NULL;
    HRESULT hResult = SHGetSpecialFolderLocation(hWndDesktop, CSIDL_DESKTOPDIRECTORY, &pidlItem);
    SHGetPathFromIDList(pidlItem, szFilename);
    strcat_s(szFilename, 100, "\\Example.bmp");
    	
    // Use the file name we generated to create the file
    try
    {
        hFile = CreateFile(szFilename,
                           GENERIC_WRITE, 
                           FILE_SHARE_READ,
                           NULL, 
                           CREATE_ALWAYS, 
                           FILE_ATTRIBUTE_NORMAL, 
                           NULL);
    }
    catch(...)
    {
        hFile = INVALID_HANDLE_VALUE;
    }
    
   if (hFile == INVALID_HANDLE_VALUE)
   
      ctlFeedback.SetWindowTextA("Failed to create the Example image file.");
   else
   {
      // Attach a CFile object to the handle we have.
      CFile myFile(hFile);

      // Writ the bitmap data, without null-terminator
      try
      {
        myFile.Write(pImage->puchBuffer, pImage->nBytesReturned);
      }
      catch(...)
      {
        ctlFeedback.SetWindowTextA("Failed to write to the Example image file.");
      }

      // We can call Close() explicitly, but the destructor would have
      // also closed the file for us. Note that there's no need to
      // call the CloseHandle() on the handle returned by the API because
      // MFC will close it for us.
      myFile.Close();
   }
}

void CImage_Capture_Sample_MFCDlg::DrawBitmap(CDC* pDC )
{
    // Setup working vars
    HBITMAP hbmImage;
    BOOL    bKeepGoing;

    // Set pointers up to the bmp information we received
    PBITMAPFILEHEADER pBmpFileHeader = (PBITMAPFILEHEADER)m_pbyReceivedBitmap;
    PBITMAPINFOHEADER pBmpInfoHeader = (PBITMAPINFOHEADER)(m_pbyReceivedBitmap + sizeof(BITMAPFILEHEADER));
    PBITMAPINFO       pBmpInfo       = (PBITMAPINFO)pBmpInfoHeader;
    PVOID             pv             = NULL;         // Pointer to data buffer.

	// Create a compatible Device Context to the form we want to display on
    CDC compatibleDC;
    bKeepGoing = compatibleDC.CreateCompatibleDC(pDC);

    // Create a compatible bitmap
    if(bKeepGoing)
    {
        hbmImage = CreateDIBSection(
                   pDC->m_hDC,      // handle to DC
                   pBmpInfo,        // bitmap data
                   DIB_RGB_COLORS,  // data type indicator
                   &pv,             // bit values
                   NULL,            // handle to file mapping object
                   0);              // offset to bitmap bit values
    }

        
    // Check that we received a BMP file
    if(bKeepGoing)
    {
        if(m_pbyReceivedBitmap[0] != (BYTE)'B')
        {
            ctlFeedback.SetWindowTextA("Image was not in BMP format.");
            bKeepGoing = false;
        }
    }
    
    // Copy the actual bitmap data from the received data into the compatible 
    // bitmap we just generated.  We find the length of the data, then where it
    // starts then copy it all in one big memory copy.
    if(bKeepGoing)
    {
        try
        {
            size_t uiLengthOfData = pBmpInfoHeader->biSizeImage;
            int    iOffset        = pBmpFileHeader->bfOffBits;
            void * pSource        = (void * )(m_pbyReceivedBitmap + iOffset);
            memcpy(pv, pSource, uiLengthOfData);
        }
        catch(...)
        {
            ctlFeedback.SetWindowTextA("Failed to copy the image data.");
        }
    }
    
    // Select the bitmap into the compatible device context
    if(bKeepGoing)
        HBITMAP hOldBmp = (HBITMAP)SelectObject( compatibleDC,hbmImage );

    // If you wish to do a straight copy....
    // do the bitblt copying the compatible device context into the visible one
    //bResult = pDC->BitBlt(5,5,pBmpInfoHeader->biWidth,pBmpInfoHeader->biHeight,&compatibleDC, 0, 0, SRCCOPY);

    // This is to allow us to stretch the image to match the form width
    // that we are drawing on.
    if(bKeepGoing)
    {
        RECT cdAreaRect;
        GetClientRect(&cdAreaRect);
        float fMultiplier = (float) cdAreaRect.right / (float)pBmpInfoHeader->biWidth;

        try
        {
            bKeepGoing = pDC->StretchBlt(  0, 
                                        0,
                                        cdAreaRect.right, 
                                        (int)(pBmpInfoHeader->biHeight * fMultiplier),
                                        &compatibleDC,
                                        0,
                                        0,
                                        pBmpInfoHeader->biWidth,
                                        pBmpInfoHeader->biHeight,
                                        SRCCOPY);
        }
        catch(...)
        {
            ctlFeedback.SetWindowTextA("Failed to bitblt the image.");
        }
    }    
    
} // End CreateImageBitmap()


LRESULT CImage_Capture_Sample_MFCDlg::OnEventHwndMsg( WPARAM eventType,LPARAM dwBytes )
{
    Result_t       nResult = RESULT_ERR_NODECODE;

    // If a capture Image Event
    if((HHI_EVENT_TYPE)eventType == HHI_IMAGE_EVENT)
    {

        HHI_EVENT_TYPE  eventType;
        HHI_IMAGE       imageStruct;
        Result_t        result;
       
        // Setup the image buffer
        imageStruct.dwStructSize        = sizeof(HHI_IMAGE);
        imageStruct.puchBuffer          = m_pbyReceivedBitmap;  // Buffer for image
        imageStruct.nBufferSize         = m_uiBufferSize;       // Size of buffer in bytes
        imageStruct.fileFormat          = FF_BMP_GRAY;          // Format for returned data
        imageStruct.dwJpegQFactor       = 80;                  // JPEG Quality Factor
        imageStruct.nBytesReturned;     // Number of bytes returned.
        imageStruct.imgSize;            // Size of image returned.
		imageStruct.nGain;              // Gain value used to capture this image
		imageStruct.nExposureTime;      // Exposure time used to capture this image




        
        try
        {
            result = hhiGetAsyncResult( &eventType, &imageStruct );
        }
        catch(...)
        {
            DWORD err = ::GetLastError();
        }
        if(RESULT_SUCCESS == result)
        {
            char szMessage [100];
            char szNumber  [10];
            _ltoa_s(imageStruct.nBytesReturned, szNumber, 10, 10);
            strcpy_s(szMessage, "Captured Image.\r\n");
            strcat_s(szMessage, szNumber);
            strcat_s(szMessage, " Bytes of data.");
            ctlFeedback.SetWindowTextA(szMessage);

            // Draw the bitmap
            m_bBitmapAvailable = TRUE;
            WriteBitmapFile(&imageStruct);
            OnPaint();
        }
        else
        {
            ctlFeedback.SetWindowTextA("Failed to catpure image data.");
        }
    }

    return( 0 );
}


void CImage_Capture_Sample_MFCDlg::OnBnClickedAsyncCaptureImage()
{
    // Give some feeback
    ctlFeedback.SetWindowTextA("Now point the scanner and pull the trigger.");
    hhiSetAsyncMethods( NULL,GetSafeHwnd(),NULL );
    SetSnapAndShipTrigger(true);
}


bool CImage_Capture_Sample_MFCDlg::GetScannerCapabilities()
{
    // Working Vars
    bool bReturn = true;
    Result_t rtResult;
    
    // Setup the structure to be used
    m_imgrCapsStruct.dwStructSize = sizeof(HHI_IMAGER_CAPS);

    // Do the read
    try
    {
        ctlFeedback.SetWindowTextA("Getting Scanner Capabilites...");
        rtResult = hhiReadImagerCapabilities(&m_imgrCapsStruct);
    }
    catch(...)
    {
       rtResult = RESULT_ERR_CAPTURE_IMAGE_FAILED;
       bReturn = FALSE;
    }

    // Give Progress
    if(RESULT_SUCCESS == rtResult)
    {
        ctlFeedback.SetWindowTextA("Ready.");
    }
    else
    {
        char szMessage [100];
        strcpy_s(szMessage, "Failure getting engine capablities.\r\n");
        strcat_s(szMessage, ErrorMessage(rtResult));
        ctlFeedback.SetWindowTextA(szMessage);
        bReturn = FALSE;
    }
    
    // Return
    return bReturn;
}
