/*======================================================================

	Image_Capture_Sample_MFC - Hand Held Imager Image Capture Sample (MFC 
    based)

	UNLESS OTHER WISE AGREED TO BY HONEYWELL INTERNATIONAL AND THE USER 
    OF THIS CODE, THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT 
    WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT 
    LIMITED TO 	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS 
    FOR A 	PARTICULAR PURPOSE.

	COPYRIGHT (C) 2000-2008 HONEYWELL INTERNALTIONAL, Inc.

	THIS SOFTWARE IS PROTECTED BY COPYRIGHT LAWS OF THE UNITED STATES OF 
	AMERICA AND OF FOREIGN COUNTRIES. THIS SOFTWARE IS FURNISHED UNDER A 
	LICENSE AND/OR A NONDISCLOSURE AGREEMENT AND MAY BE USED IN ACCORDANCE 
	WITH THE TERMS OF THOSE	AGREEMENTS. UNAUTHORIZED REPRODUCTION, 
	DUPLICATION OR DISTRIBUTION OF THIS SOFTWARE, OR ANY PORTION OF IT 
	WILL BE PROSECUTED TO THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW.

	Module:		 Image_Capture_Sample_MFCDlg.h
	
	Description: Class declaration file for the MFC dialog of the 
    Image Capture Sample application.
				
======================================================================*/
// Image_Capture_Sample_MFCDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include <hhiImgrSdk.h>


// CImage_Capture_Sample_MFCDlg dialog
class CImage_Capture_Sample_MFCDlg : public CDialog
{
// Construction
public:
	CImage_Capture_Sample_MFCDlg(CWnd* pParent = NULL);	// standard constructor
    ~CImage_Capture_Sample_MFCDlg();

// Dialog Data
	enum { IDD = IDD_IMAGE_CAPTURE_SAMPLE_MFC_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
    afx_msg LRESULT OnEventHwndMsg( WPARAM,LPARAM );
	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnBnClickedConnect();
public:
    CStatic ctlFeedback;
public:
    CEdit ctrl_CEdit_Comm;
private:
    LPCTSTR ErrorMessage(Result_t errorCode);
    BOOL DisplayBitmapImage( PHHI_IMAGE pImage );
    void WriteBitmapFile( PHHI_IMAGE pImage );
    HBITMAP LoadAnImage(char* FileName);
    void DrawBitmap(CDC* pDC);
    bool GetScannerCapabilities();

    afx_msg void OnBnClickedDisconnect();
    afx_msg void OnBnClickedCaptureImage();
    
    CStatic         ctrl_Picture_Data;
    BYTE*           m_pbyReceivedBitmap;
    unsigned int    m_uiBufferSize;
    BOOL            m_bBitmapAvailable;
    HHI_IMAGER_CAPS m_imgrCapsStruct;
    
    afx_msg void OnBnClickedAsyncCaptureImage();
    bool  SetSnapAndShipTrigger( bool bSet );
};
